
; Deplacer le joueur en fonction de la gravite
GRAVITY:
	ld	hl, gravity_mode
	ld	a, (hl)
	cp	0	; O est normal
	jp	z, g_normal

	call	ANTI_GRAVITY
	ret

g_normal:
	call	NORMAL_GRAVITY
	ret

; Inverser la gravite
GRAVITY_SWITCH:
	ld	hl, gravity_mode
	ld	a, (hl)
	cp	0
	jp	z, gs_mettre_un
	ld	a, 0
	ld	(hl), a
	ret

gs_mettre_un:
	ld	a, 1
	ld	(hl), a
	ret

gravity_mode:
	.db	0

; Gravite vers le bas
NORMAL_GRAVITY:
	ld	a, (xcoord)
	ld      b,00000111b     ; Get the remainder of x/8
        and     b   
        ld      c, a            ; Sauver dans c
        cp      0               ; Is this sprite aligned to 8*n,y?
        jp      z,ng_aligne
        jp      ng_non_aligne

ng_aligne:
	ld      a, (xcoord)
        call    DIVIDE_A_BY_EIGHT
        ld      e, a
        ld      a, (ycoord)
        call    DIVIDE_A_BY_EIGHT
	inc	a
        ld      c, a
        call    FIELD_GET
        cp      2
        jp      p, g_touche_le_sol
	jp	g_nul_ne_peut_echapper_a_la_gravite
	
ng_non_aligne:
	ld      a, (xcoord)
        call    DIVIDE_A_BY_EIGHT
        ld      e, a
        ld      a, (ycoord)
        call    DIVIDE_A_BY_EIGHT
	inc	a
        ld      c, a
        call    FIELD_GET
        cp      2
        jp      p, g_touche_le_sol

        ld      a, (xcoord)
        add     a, 8
        call    DIVIDE_A_BY_EIGHT
        ld      e, a
        ld      a, (ycoord)
        call    DIVIDE_A_BY_EIGHT
	inc	a
        ld      c, a
        call    FIELD_GET
        cp      2
        jp      p, g_touche_le_sol

g_nul_ne_peut_echapper_a_la_gravite:
        ld      hl, ycoord
        ld      a, (hl)
	ld	hl, oldycoord
	ld	(hl), a
        add     a, 1
        ld      (ycoord), a
        ld      a, 1
	ld	(is_on_the_floor), a
        ret

g_touche_le_sol:
        ld      hl, ycoord
        ld      a, (hl)
	ld	hl, oldycoord
	ld	(hl), a
        ld      a, 0
	ld	(is_on_the_floor), a
        ret

; Gravite vers le haut
ANTI_GRAVITY:
	ld	a, (xcoord)
	ld      b,00000111b     ; Get the remainder of x/8
        and     b   
        ld      c, a            ; Sauver dans c
        cp      0               ; Is this sprite aligned to 8*n,y?
        jp      z,ag_aligne
        jp      ag_non_aligne


ag_aligne:
	ld      a, (xcoord)
        call    DIVIDE_A_BY_EIGHT
        ld      e, a
        ld      a, (ycoord)
	dec	a
        call    DIVIDE_A_BY_EIGHT
        ld      c, a
        call    FIELD_GET
        cp      2
        jp      p, ag_touche_le_sol
	jp	ag_nul_ne_peut_echapper_a_la_gravite

ag_non_aligne:
	ld      a, (xcoord)
        call    DIVIDE_A_BY_EIGHT
        ld      e, a
        ld      a, (ycoord)
	dec	a
        call    DIVIDE_A_BY_EIGHT
        ld      c, a
        call    FIELD_GET
        cp      2
        jp      p, ag_touche_le_sol

        ld      a, (xcoord)
        add     a, 8
        call    DIVIDE_A_BY_EIGHT
        ld      e, a
        ld      a, (ycoord)
	dec	a
        call    DIVIDE_A_BY_EIGHT
        ld      c, a
        call    FIELD_GET
        cp      2
        jp      p, ag_touche_le_sol

ag_nul_ne_peut_echapper_a_la_gravite:
        ld      hl, ycoord
        ld      a, (hl)
        sub     1
        ld      (ycoord), a
        ld      a, 1
	ld	(is_on_the_floor), a
        ret

ag_touche_le_sol:
        ld      a, 0
	ld	(is_on_the_floor), a
        ret


is_on_the_floor:
	.db	1

; Diviser par 8
DIVIDE_A_BY_EIGHT:
        srl     a   
        srl     a   
        srl     a   
        ret 


