

; From bill nagel
GRAYLEVELS_ON:
	
	ld HL,$8300
	ld DE,$8301
	ld BC,256
	ld (HL),$85
	ldir
	ld HL,INTERRUPT       ; Get pointer to interrupt rutine
	ld DE,$8585              ; Start of int rutine, and length of it
	ld BC,INTERRUPT_END-INTERRUPT+1
	ldir

	xor A                    ; Init vars
	ld ($8583),A
	ld A,$83	             ; Point to the new table
	ld I,A
	im 2
	ret

GRAYLEVELS_OFF:
    im 1                     ; Normal interrupt mode
    set 0,(IY+3)             ; Graph is dirty
    ret	


INTERRUPT:
    ex AF,AF'
    exx
    ld HL,$8583
    inc (HL)
    ld A,(HL)
    cp 0                ; If Counter=1 then display picture 1
    call z,FASTCOPY_BG
    cp 1
    call z, FASTCOPY_FG

I_EXIT:
    exx
    ex AF,AF'
    jp $0038         

INTERRUPT_END:


; Copy one of the two buffer (needed for graylevels)
FASTCOPY_BG: 
	ld hl, buffer_bg
	ld de, PLOTSSCREEN
	ld bc, 768
	ldir

	call	FASTCOPY
	ld	hl, $8584
	ld	(hl), 1
	ret

; Copy the other buffer !
FASTCOPY_FG: 
	ld hl, buffer_fg
	ld de, PLOTSSCREEN
	ld bc, 768
	ldir

	call	FASTCOPY
	ld	hl, $8584
	ld	(hl), 0
	ret



