.nolist
#define EQU .equ 
#include "includes/ti83asm.inc"
#include "includes/tokens.inc"
#define xcoord 8270h
#define ycoord 8271h
#define oldxcoord 8272h
#define oldycoord 8273h
.list

.org 9327h

; Header pour ION
	xor	a	; xor car on n'utilise pas les libs              
	jr	nc,start      
.db   "Gravity",0
; Voila c'est fini

start:
	call	RINDOFF


menu:
	
	ld	a, 1
	ld	(game_run), a
	ld	a, 0
	ld	(game_quit), a
	ld	a, 0
	ld	(decalage), a
	ld      hl, buffer
	ld      (pointeur_sur_buffer), hl
	call	MENU_PRINT
	call	MENU_RUN
	call	CHOOSE_LEVEL

	call	PLAYER_INIT

	call	COPY_MAP_INTO_FIELD
	call	FIELD_PRINT
	call	PLAYER_PRINT
	call	COPY_BUFFER_INTO_PLOTSSCREEN
	call	FASTCOPY
	

loop:
	ei
	halt
	call	MOVE_SCAN_KEY	; Les déplacements
	
	call	PLAYER_SAVE_COORD
	call	COLLISION
	call	GRAVITY
	call	PROTECT_ARENA
	call	DEL_SCAN_KEY	; Les déplacements
	ld	hl, game_quit
	ld	a, (hl)
	or	a
	jp	nz, end_game
	ld	hl, game_run
	ld	a, (hl)
	or	a
	jp	z, menu
	call	PLAYER_ANIM_IF_NEEDED		; Change the player sprite
	call	PLAYER_ERASE			; Erase the player before scrolling
	call    SCROLL_RIGHT_IF_POSSIBLE	; Scroll
	call	PLAYER_PRINT			; Print the player
	call    COPY_BUFFER_INTO_PLOTSSCREEN	; Copy the buffer into graphbuf
	call    FASTCOPY			; Copy to the screen

	jp	loop

end_game:
	ld hl, nom_prog
	call _ChkFindSym		;de = addresse du programme dans la mémoire 
	ld hl, best_level - $9327 + 4  	;plus 4 parce que les 4 premiers octets du programme sont: 2 octets pour la taille et 2 pour le AsmPrgm token 
	add hl,de             		;hl = l'addresse de "highscore" 
	ex de,hl 
	ld hl, best_level
	ld bc, best_level_end - best_level 
	ldir                  ;sauvegarder les données :) 

	ret

nom_prog:
	.db "GRAVITY", 0

#include "move.asm"
#include "lib/fastcopy.asm"
#include "screen_buffers.asm"
#include "field.asm"
#include "player.asm"
#include "gravity.asm"
#include "collision.asm"
#include "sprites.data.asm"
#include "bigbuf.asm"
#include "buffer.asm"
#include "title.asm"
#include "level.asm"
#include "menu.asm"
#include "map.asm"
