MENU_PRINT:
	call	HEADER_PRINT
	call	BORDER_PRINT
	call	COPY_BUFFER_INTO_PLOTSSCREEN
	call	LEVEL_PRINT
	call	CHOOSE_LEVEL
	call	FASTCOPY
	ret

MENU_RUN:
menu_loop:
	call    _getkey
        cp      1       ; <-
        jp      z, inc_level
        cp      2       ; ->
        jp      z, dec_level
        cp      5       ; enter
	jp	nz, menu_loop
	; Si on a presse enter, verifier si on est sur locked
	ld      a, (current_level)
	ld      hl, best_level
	cp      (hl)
	ret	m
        cp      10
        jp      menu_loop

inc_level:
	; Ne pas depasser le nombre de niveaux
	ld	hl, current_level
	ld	a, (hl)
	ld	hl, level_max
	ld	b, (hl)
	cp	b
	jp	p, menu_loop
	
	; Eviter d'aller trop loin dans les lock
	ld	a, (current_level)
	ld	hl, best_level
	cp	(hl)
	jp	p, menu_loop

	ld	hl, current_level
	inc	(hl)
	call	LEVEL_PRINT
	call	FASTCOPY
	jp	menu_loop

dec_level:
	ld	hl, current_level
	ld	a, (hl)
	cp	2
	jp	m, menu_loop
	dec	(hl)
	call	LEVEL_PRINT
	call	FASTCOPY
	jp	menu_loop

	

HEADER_PRINT:
	ld	b, 10
	ld	hl, title
	ld	de, buffer + (8 * 13)
tp_loop:
	push	bc
	ld	bc, 12
	ldir
	inc	de
	pop	bc
	djnz	tp_loop
	
	ld	b, 44
tp_loop2:
	push	bc
	ld	b, 12
tp_loop3:
	push	bc
	ld	a, 11111111b
	ld	(de),a
	inc	de
	pop	bc
	djnz	tp_loop3
	inc	de
	pop	bc
	djnz	tp_loop2

	ret

LEVEL_PRINT:
	set textWrite, (iy + sGrFlags)
	set textInverse,(IY+TextFlags)
	ld     a,27
        ld     (penrow),a   
        ld     a,23
        ld     (pencol),a   
        ld     hl, select_level
        call    _vputs

	ld     a,40
        ld     (penrow),a   
        ld     a,18
        ld     (pencol),a   
        ld     hl, left_arrow
        call    _vputs
	
	ld     a,40
        ld     (penrow),a   
        ld     a,70
        ld     (pencol),a   
        ld     hl, right_arrow
        call    _vputs

	ld	a, (current_level)
	ld	hl, best_level
	cp	(hl)
	jp	m, lp_unlocked

lp_locked:
	ld     a,40
        ld     (penrow),a   
        ld     a,30
        ld     (pencol),a   
	ld	hl, locked
        call    _vputs
	ret

lp_unlocked:
	ld	hl, levels - 11
	ld	de, 11
	ld	a, (current_level)
	ld	b, a
lp_loop:
	add	hl, de
	djnz	lp_loop

	ld     a,40
        ld     (penrow),a   
        ld     a,30
        ld     (pencol),a   
        call    _vputs

	ret


level_max:
	.db	7
current_level:
	.db	1
best_level:
	.db	3
best_level_end:

select_level:
	.db "Select a level", 0
left_arrow:
	.db $cf, 0
right_arrow:
	.db $05, 0

locked:
	.db $3c, "locked", $3e, $06, $06, 0
levels:
one:
	.db "1-icecube", $06, 0	
two:
	.db "2-rocks", $06, $06, $06, 0
three:
	.db "3-blocks", $06, $06, 0
four:
	.db "4-fantom", $06, $06, 0
five:
	.db "5-agility", $06, 0
six:
	.db "6-curious", $06, 0
seven:
	.db "7-odd", $06, $06, $06, $06, $06,0




BORDER_PRINT:

;; Boucle pour afficher les blocs en haut
	ld	a, 0
	ld	e, 0
	ld	ix, bloc2
	ld	b, 12
bp_loop:
	push	bc
	push	af
	push	hl
	push	de
	push	ix
	call	DRAW_SPRITE
	pop	ix
	pop	de
	pop	hl
	pop	af
	add	a, 8
	pop	bc
	djnz	bp_loop

;; Boucle pour afficher les blocs sur les cotés
	ld	e, 8
	ld	a, 0
	ld	b, 6
bp_bigloop:
	push	bc
	ld	b, 2
bp_loop1:
	push	bc
	push	af
	push	hl
	push	de
	push	ix
	call	DRAW_SPRITE
	pop	ix
	pop	de
	pop	hl
	pop	af
	add	a, 8 * 11
	pop	bc
	djnz	bp_loop1

	ld	a, e
	add	a, 8
	ld	e, a
	ld	a, 0
	pop	bc
	djnz	bp_bigloop

;; Boucle pour afficher les blocs en bas
	ld	a, 0
	ld	e, 55
	ld	b, 12
bp_loop2:
	push	bc
	push	af
	push	hl
	push	de
	push	ix
	call	DRAW_SPRITE
	pop	ix
	pop	de
	pop	hl
	pop	af
	add	a, 8
	pop	bc
	djnz	bp_loop2
	ret








