; Scanner le clavier et deplacer le personnage
MOVE_SCAN_KEY:
	ld     	a,$FE            
	out    	(1),a            
	in     	a,(1)            
	cp     	247            
	jp     	z,msk_up
	cp     	254              
	jp     	z,msk_down       
	jp 	msk_rien
	
msk_up:
	ld	a, (gravity_mode)
	cp	0
	ret	nz
	ld	a, (is_on_the_floor)
	cp	0
	call	z, GRAVITY_SWITCH
	ret

msk_down:
	ld	a, (gravity_mode)
	cp	1
	ret	nz
	ld	a, (is_on_the_floor)
	cp	0
	call	z,GRAVITY_SWITCH
	ret

msk_rien:
	ret

; Test if the player selects a block  
DEL_SCAN_KEY:
        ld     a,$FF     
        out    (1),a     
        ld     a,$FD            ; scanner le groupe
        out    (1),a     
        in     a,(1)     
        cp      191 
        jp      z, dsk_del
	jp	dsk_rien

dsk_del:
	ld	hl, game_quit
	ld	a, 1
	ld	(hl), a

dsk_rien:
	ret

; Lorsque que game_quit == 1, on quitte
game_quit:
	.db 0



; Le scrolling vers la droite
SCROLL_RIGHT_IF_POSSIBLE:
	call	TEST_IF_OUT_OF_MAP
	cp	0
	jp	z,avancer_le_joueur
	
	; Sinon tester si on doit smooth scroller ou 8x8 scroller
	call	DEC_SCROLL_COUNTER
	cp	0
	jp	z, smooth
not_smooth:
	; Incrementer le compteur
        call    INC_SHIFT 
	call	COPY_MAP_INTO_FIELD
	call	FIELD_PRINT
	ret
smooth: 
	call	SCROLL_RIGHT
        ret 

ne_pas_scroll:
        ret

; Lorsqu'on finit le niveau, la boule va tout a droite
avancer_le_joueur:
	ld	hl, xcoord
	inc	(hl)
	halt
	halt
	halt
	halt
	halt
	halt
	ret

; Retourne 0 si smooth scroll
; Retourne 1 si 8x8 scroll
DEC_SCROLL_COUNTER:
	ld	hl, cpt_scroll
	dec	(hl)
	ld	a, (hl)
	cp	1
	jp	m, reset
	ld	a, 0
	ret
reset:
	
	ld	a, 9
	ld	(hl), a
	ld	a, 1
	ret

cpt_scroll:
	.db	0


; Retourne 0 si hors de la map
; Retourne 1 sinon
TEST_IF_OUT_OF_MAP:
        ld      hl, decalage
        ld      a, (hl)
	add	a, 12
	ld	hl, max_shift 
        cp      (hl)
        jp      p, out_of_map
	ld	a, 1
	ret

out_of_map:
	ld	a, 0
	ret
	

INC_SHIFT:
        ld      hl, decalage
        ld      a, (hl)
	add	a, 12
	ld	hl, max_shift 
        cp      (hl)
        jp      p, is_ne_pas_inc
        ld      hl, decalage
        inc     (hl)
        ld      a, 1
        ret

is_ne_pas_inc:
        ld      a, 0
        ret

; Mettre a jour le decor
; Copie le bout de map utile dans field
COPY_MAP_INTO_FIELD:
        ld      hl, (pointeur_sur_level)
        ld      a, (decalage)	

        ld      d, 0
        ld      e, a
        add     hl, de
        ld      de, field
        ld      b, 8
copy_it:
	; Copier la ligne
        push    bc  
        ld      bc, 13
        ldir
	; Puis aller a la ligne suivante
        push    de  
	push	af
	ld	a, (max_shift)
	sub	13
	ld	d, 0
	ld	e, a
	pop	af
        add     hl, de
        pop     de  
        pop     bc  
        djnz    copy_it

        ret 

