PLAYER_INIT:
	; Position de départ
	ld	hl, xcoord
	ld	a, 30
	ld	(hl), a
	ld	hl, ycoord
	ld	a, 30
	ld	(hl), a
	ld	hl, oldxcoord
	ld	a, 30
	ld	(hl), a
	ld	hl, oldycoord
	ld	a, 30
	ld	(hl), a

	; Sprite de départ
	ld      hl, ball0
        ld      (pointeur_sur_focus), hl
        ld      (pointeur_sur_oldfocus), hl
	ret

PLAYER_SAVE_COORD:
	ld	a, (xcoord)
	ld	(oldxcoord), a
	ld	a, (ycoord)
	ld	(oldycoord), a
	ret

PLAYER_ERASE:
	ld      hl, buffer
        ld      (pointeur_sur_buffer), hl
        ld      a,(oldxcoord)
        ld      de,(oldycoord)
        ld      d,0 
        ld      ix, (pointeur_sur_oldfocus)
        call    DRAW_SPRITE_XOR
	ret

PLAYER_PRINT:
	ld      hl, buffer
        ld      (pointeur_sur_buffer), hl
        ld      a,(xcoord)
        ld      de,(ycoord)
        ld      d,0 
        ld      ix, (pointeur_sur_focus)
        call    DRAW_SPRITE_XOR
	ret

PLAYER_ANIM_IF_NEEDED:
	call	PLAYER_SAVE_OLD
	ld	hl, cpt_anim_slow
	dec	(hl)
	ld	a, (hl)
	cp	0
	jp	m, pain_anim
	ret
pain_anim:
	ld	a, 3
	ld	(hl), a
	call	PLAYER_ANIM
	ret

PLAYER_ANIM:
	ld	a, (gravity_mode)
	cp	0
	jp	z, pa_gravity_normal
	jp	pa_anti_gravity
	
pa_anti_gravity:
	ld	hl, cpt_anim
	inc	(hl)
	ld	a, (hl)
	cp	5
	jp	p, pa_anti_gravity_reset

	; Se positionner sur le prochain sprite
	ld	hl, (pointeur_sur_focus)
	ld	e, 8
	ld	a, l
	sub	e
	ld	l, a
        ld      (pointeur_sur_focus), hl
	ret

pa_anti_gravity_reset:
	; Remettre le sprite 0
	ld	a, 0
	ld	(hl), a
	ld	hl, ball5
        ld      (pointeur_sur_focus), hl
	ret



pa_gravity_normal:
	ld	hl, cpt_anim
	dec	(hl)
	ld	a, (hl)
	cp	0
	jp	m, pa_gravity_normal_reset

	; Se positionner sur le prochain sprite
	ld	hl, (pointeur_sur_focus)
	ld	de, 8
	add	hl, de
        ld      (pointeur_sur_focus), hl
	ret

pa_gravity_normal_reset:
	; Remettre le sprite 0
	ld	a, 5
	ld	(hl), a
	ld	hl, ball0
        ld      (pointeur_sur_focus), hl
	ret
	
cpt_anim:
	.db	5
cpt_anim_slow:
	.db	3

PLAYER_SAVE_OLD:
	ld	hl, (pointeur_sur_focus)
	ld	(pointeur_sur_oldfocus), hl	
	ret
	
