; ix = le sprite a afficher
; a = x
; e = y
DRAW_SPRITE:

	; y * 12
	ld	hl, 0
	ld	d, 0
	add	hl, de	; 1
	add	hl, de	; 2
	add	hl, de	; 3
	add	hl, hl	; 6
	add	hl, hl	; 12
	
	; x / 8
	ld	d, 0
	ld	e, a
	srl	e	; / 2
	srl	e	; / 4
	srl	e	; / 8
	add	hl, de

	; A present on a le decalage dans hl
	
	ld	de, (pointeur_sur_buffer)	; Prendre le debut du graphbuffer
	add	hl, de		; Puis ajouter le decalage

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	ld	c, a		; Sauver dans c
	cp      0               ; Is this sprite aligned to 8*n,y?
	jp      z,ds_aligne
	jp	ds_non_aligne

	
ds_aligne:
	ld	b, 8	; Sprite 8 de hauteur
ds_aligne_loop:
	push	bc
	ld	a, (ix)
	ld	(hl), a
	ld	de, 12
	inc	ix
	add	hl, de 
	pop	bc
	djnz	ds_aligne_loop

	jp	ds_fin

; a= decalage
ds_non_aligne:
	ld	b, 8
ds_non_aligne_loop:
	push	bc
	ld	b, c	; On va utiliser le nombre de rotations comme compteur
	ld	a, (ix)	; L'octet qu'il faut decaler 
	ld	e, 0

ds_shift_loop:
	push	bc	; Ici on sauve en meme temps le compteur b et le decalage c
	; Mettre la carry a 0?
	srl	a	; Decaler a vers la droite et ce qui sort va en carry
	rr	e	; Injecter la carry dans e

	pop	bc
	djnz	ds_shift_loop
	
	ld	(hl), a	; Ecrire le premier octet
	inc	hl	; Avancer d'un cran
	inc	ix
	ld	a, e	
	ld	(hl), a ; Ecrire le second octet

	ld	de, 11
	add	hl, de 
	
	pop	bc
	djnz	ds_non_aligne_loop
	
ds_fin:
	ret
	
; ix = le sprite a afficher
; a = x
; e = y
DRAW_SPRITE_OR:

	; y * 12
	ld	hl, 0
	ld	d, 0
	add	hl, de	; 1
	add	hl, de	; 2
	add	hl, de	; 3
	add	hl, hl	; 6
	add	hl, hl	; 12
	
	; x / 8
	ld	d, 0
	ld	e, a
	srl	e	; / 2
	srl	e	; / 4
	srl	e	; / 8
	add	hl, de

	; A present on a le decalage dans hl
	
	ld	de, (pointeur_sur_buffer)	; Prendre le debut du graphbuffer
	add	hl, de		; Puis ajouter le decalage

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	ld	c, a		; Sauver dans c
	cp      0               ; Is this sprite aligned to 8*n,y?
	jp      z,dso_aligne
	jp	dso_non_aligne

	
dso_aligne:
	ld	b, 8	; Sprite 8 de hauteur
dso_aligne_loop:
	push	bc
	ld	a, (ix)
	or	(hl)
	ld	(hl), a
	ld	de, 12
	inc	ix
	add	hl, de 
	pop	bc
	djnz	dso_aligne_loop

	jp	dso_fin

; a= decalage
dso_non_aligne:
	ld	b, 8
dso_non_aligne_loop:
	push	bc
	ld	b, c	; On va utiliser le nombre de rotations comme compteur
	ld	a, (ix)	; L'octet qu'il faut decaler 
	ld	e, 0

dso_shift_loop:
	push	bc	; Ici on sauve en meme temps le compteur b et le decalage c
	; Mettre la carry a 0?
	srl	a	; Decaler a vers la droite et ce qui sort va en carry
	rr	e	; Injecter la carry dans e

	pop	bc
	djnz	dso_shift_loop
	
	or	(hl)
	ld	(hl), a	; Ecrire le premier octet
	inc	hl	; Avancer d'un cran
	inc	ix
	ld	a, e	
	or	(hl)
	ld	(hl), a ; Ecrire le second octet

	ld	de, 11
	add	hl, de 
	
	pop	bc
	djnz	dso_non_aligne_loop
	
dso_fin:
	ret
	

	
; ix = le sprite a afficher
; a = x
; e = y
DRAW_SPRITE_AND:

	; y * 12
	ld	hl, 0
	ld	d, 0
	add	hl, de	; 1
	add	hl, de	; 2
	add	hl, de	; 3
	add	hl, hl	; 6
	add	hl, hl	; 12
	
	; x / 8
	ld	d, 0
	ld	e, a
	srl	e	; / 2
	srl	e	; / 4
	srl	e	; / 8
	add	hl, de

	; A present on a le decalage dans hl
	
	ld	de, (pointeur_sur_buffer)	; Prendre le debut du graphbuffer
	add	hl, de		; Puis ajouter le decalage

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	ld	c, a		; Sauver dans c
	cp      0               ; Is this sprite aligned to 8*n,y?
	jp      z,dsa_aligne
	jp	dsa_non_aligne

	
dsa_aligne:
	ld	b, 8	; Sprite 8 de hauteur
dsa_aligne_loop:
	push	bc
	ld	a, (ix)
	and	(hl)
	ld	(hl), a
	ld	de, 12
	inc	ix
	add	hl, de 
	pop	bc
	djnz	dsa_aligne_loop

	jp	dsa_fin

; a= decalage
dsa_non_aligne:
	ld	b, 8
dsa_non_aligne_loop:
	push	bc
	ld	b, c	; On va utiliser le nombre de rotations comme compteur
	ld	a, (ix)	; L'octet qu'il faut decaler 
	ld	e, 0

dsa_shift_loop:
	push	bc	; Ici on sauve en meme temps le compteur b et le decalage c
	; Mettre la carry a 0?
	srl	a	; Decaler a vers la droite et ce qui sort va en carry
	rr	e	; Injecter la carry dans e

	pop	bc
	djnz	dsa_shift_loop
	
	and	(hl)
	ld	(hl), a	; Ecrire le premier octet
	inc	hl	; Avancer d'un cran
	inc	ix
	ld	a, e	
	and	(hl)
	ld	(hl), a ; Ecrire le second octet

	ld	de, 11
	add	hl, de 
	
	pop	bc
	djnz	dsa_non_aligne_loop
	
dsa_fin:
	ret


	
; ix = le sprite a afficher
; a = x
; e = y
DRAW_SPRITE_XOR:

	; y * 12
	ld	hl, 0
	ld	d, 0
	add	hl, de	; 1
	add	hl, de	; 2
	add	hl, de	; 3
	add	hl, hl	; 6
	add	hl, hl	; 12
	
	; x / 8
	ld	d, 0
	ld	e, a
	srl	e	; / 2
	srl	e	; / 4
	srl	e	; / 8
	add	hl, de

	; A present on a le decalage dans hl
	
	ld	de, (pointeur_sur_buffer)	; Prendre le debut du graphbuffer
	add	hl, de		; Puis ajouter le decalage

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	ld	c, a		; Sauver dans c
	cp      0               ; Is this sprite aligned to 8*n,y?
	jp      z,dsx_aligne
	jp	dsx_non_aligne

	
dsx_aligne:
	ld	b, 8	; Sprite 8 de hauteur
dsx_aligne_loop:
	push	bc
	ld	a, (ix)
	xor	(hl)
	ld	(hl), a
	ld	de, 12
	inc	ix
	add	hl, de 
	pop	bc
	djnz	dsx_aligne_loop

	jp	dsx_fin

; a= decalage
dsx_non_aligne:
	ld	b, 8
dsx_non_aligne_loop:
	push	bc
	ld	b, c	; On va utiliser le nombre de rotations comme compteur
	ld	a, (ix)	; L'octet qu'il faut decaler 
	ld	e, 0

dsx_shift_loop:
	push	bc	; Ici on sauve en meme temps le compteur b et le decalage c
	; Mettre la carry a 0?
	srl	a	; Decaler a vers la droite et ce qui sort va en carry
	rr	e	; Injecter la carry dans e

	pop	bc
	djnz	dsx_shift_loop
	
	xor	(hl)
	ld	(hl), a	; Ecrire le premier octet
	inc	hl	; Avancer d'un cran
	inc	ix
	ld	a, e	
	xor	(hl)
	ld	(hl), a ; Ecrire le second octet

	ld	de, 11
	add	hl, de 
	
	pop	bc
	djnz	dsx_non_aligne_loop
	
dsx_fin:
	ret
